#include <windows.h>
#include <stdio.h>

LRESULT CALLBACK WindowProc(HWND,UINT,WPARAM,LPARAM);
void ErrMsgDlgBox(LPCTSTR);

char *GetNextCmdLineParam(char *,char *);

int WINAPI WinMain (HINSTANCE hTI, HINSTANCE hPI, LPSTR lpszargs, int nWinMode) {
	int n;
	DWORD type;
	MSG msg;
	HANDLE indir;
	char f_path[1024];//="c:\\temp\\test";
	char msgt[2048],pr[512],f_dir[1032];//="mspaint.exe";
	char *t=lpszargs;
	HKEY hk;

	t=GetNextCmdLineParam(f_path,t);
	t=GetNextCmdLineParam(msgt,t);
	if (!*f_path) {
		MessageBox(NULL,"FDelDaem.exe FileName [Message]","FileDelDaemon v0.2 usage:",MB_OK);
		return 2;
	}
	if (!*msgt) {
		RegCreateKey(HKEY_LOCAL_MACHINE,"Software\\FDelDaemon",&hk);
		n=2048;
		RegQueryValueEx(hk,f_path,NULL,&type,(BYTE*)msgt,(DWORD*)&n);
		RegCloseKey(hk);
		if (!*msgt) sprintf(msgt,"Why did you delete this file?");
	}
	t=GetNextCmdLineParam(pr,t);
	n=strlen(f_path);
	if (f_path[n-1]=='\\') f_path[n-1]=0;
	GetFullPathName(f_path,1024,f_dir,&t);
	*t=0; if (t!=f_dir && *(t-1)=='\\') *(--t)=0;
	//MessageBox(NULL,f_dir,"f_dir",0);
	//strcat(f_dir,"\\*.*");
	indir=FindFirstChangeNotification(f_dir,FALSE,FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_LAST_WRITE | FILE_NOTIFY_CHANGE_DIR_NAME);
	if (indir==INVALID_HANDLE_VALUE) {
		ErrMsgDlgBox(/*"FDelDaemon could not be started"*/f_dir);
		return 1;
	}
	while (true) {
		if (PeekMessage(&msg,NULL,0,0,PM_NOREMOVE)) {
			GetMessage(&msg,NULL,0,0);
			if (msg.message==WM_QUIT) break;
		}
		//Sleep(500);
		if (WaitForSingleObject(indir,50)!=WAIT_TIMEOUT) {
			FindNextChangeNotification(indir);
			if (GetFileAttributes(f_path)==0xFFFFFFFF) {
				if (RegCreateKey(HKEY_CURRENT_USER,"Software\\FDelDaemon",&hk)==ERROR_SUCCESS) {
					if (RegQueryValueEx(hk,f_path,NULL,&type,NULL,NULL)!=ERROR_SUCCESS) {
						unsigned char ctime[512];
						SYSTEMTIME time;
						GetLocalTime(&time);
						sprintf((char*)ctime,"%i.%i.%i-%i:%i:%i",time.wDay,time.wMonth,time.wYear,time.wHour,time.wMinute,time.wSecond);
						RegSetValueEx(hk,f_path,NULL,REG_SZ,ctime,sizeof(ctime));
					}
					RegCloseKey(hk);
				}
				MessageBox(NULL,msgt,f_path,MB_OK | MB_ICONEXCLAMATION | MB_SYSTEMMODAL);
			}
		}
	}
	FindCloseChangeNotification(indir);
	//MessageBox(NULL,"Closed!","fdeldaemon",0);
	return 0;
}

void ErrMsgDlgBox(LPCTSTR sss) {
        TCHAR* lpMsgBuf;
        DWORD n=500;
        DWORD LE=GetLastError();

        FormatMessage( 
                FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
                NULL,
                LE,
                MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                (LPTSTR)&lpMsgBuf,
                0,
                NULL 
        );
        MessageBox( NULL, lpMsgBuf, sss, MB_OK|MB_ICONINFORMATION );
        LocalFree( lpMsgBuf );
}

char *GetNextCmdLineParam(char *dst,char *src) {
	char prevc=0;
	for(;*src==' ';src++);
	if (*src!='\"') {
		for(;*src!=' ' && *src;src++,dst++) *dst=*src;
		*dst=0;
		return src;
	}
	src++;
	for(;*src && (*src!='\"' || prevc=='\\'|| *(src+1)=='\"');src++,dst++) prevc=*dst=*src;
	*dst=0;
	return src+1;
}
